%{!?upstream_version: %global upstream_version %{version}}
%global upstream_name tripleo-common

%{?!_licensedir:%global license %%doc}

Name:           openstack-tripleo-common
Summary:        Python library for code used by TripleO projects.
Version:        7.6.3
Release:        8%{?dist}
License:        ASL 2.0
URL:            https://github.com/rdo-management/tripleo-common

Source0:        https://tarballs.openstack.org/%{upstream_name}/%{upstream_name}-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=7.6.3
Patch0001: 0001-OSP-12-Only-Include-docker.yaml-and-docker-ha.yaml-b.patch
Patch0002: 0002-OSP-12-Only-Drop-barbican-tacker-and-congress-contai.patch
Patch0003: 0003-Remove-mongodb-and-qdrouterd.patch
Patch0004: 0004-Only-add-docker.yaml-if-it-exists.patch
Patch0005: 0005-Check-for-the-existence-of-docker-ha.yaml.patch
Patch0006: 0006-Set-container-image-names-for-downstream.patch
Patch0007: 0007-Get-a-static-inventory-for-upgrade-non-controller-an.patch
Patch0008: 0008-Action-to-always-populate-container-image-parameters.patch
Patch0009: 0009-Add-retry-loop-for-docker-pull.patch
Patch0010: 0010-Fix-typos-in-container_images_prepare-failure-task-n.patch
Patch0011: 0011-Add-zaqarclient-to-TripleOAction.patch
Patch0012: 0012-Do-not-update-the-container-registry-if-is-None.patch
Patch0013: 0013-Update-ceph-ansible-playbook-path-in-parameter-defau.patch
Patch0014: 0014-Truncate-the-zaqar-message-to-512-kbytes.patch
Patch0015: 0015-Stream-the-Ansible-output-to-a-Zaqar-queue.patch
Patch0016: 0016-Generate-password-for-libvirt-TLS-SCRAM-auth.patch
Patch0017: 0017-Handle-false-in-when-statements-for-ansible-upgrade_.patch
Patch0018: 0018-Add-httpd-packages-to-ec2api-image.patch
Patch0019: 0019-config-Always-add-step-conditional-first-for-upgrade.patch
Patch0020: 0020-Prevent-apache-from-listening-on-default-ports.patch
Patch0021: 0021-Consume-resource-registry-in-ProcessTemplatesAction.patch
Patch0022: 0022-Add-exclude-list-to-not-override-user-data.patch

BuildArch:      noarch
BuildRequires:  git
BuildRequires:  python-setuptools
BuildRequires:  python2-devel
BuildRequires:  python-pbr

Requires: GitPython
Requires: python-jinja2
Requires: python-gitdb
Requires: python-glanceclient >= 2.7.0
Requires: python-heatclient >= 1.6.1
Requires: python-ironic-inspector-client >= 1.5.0
Requires: python-ironicclient >= 1.14.0
Requires: python-novaclient >= 1:9.0.0
Requires: python-mistral-lib >= 0.2.0
Requires: python-mistralclient >= 3.1.0
Requires: python-netaddr
Requires: python-netifaces
Requires: python-oslo-concurrency >= 3.8.0
Requires: python-oslo-config >= 2:4.0.0
Requires: python-oslo-log >= 3.22.0
Requires: python-oslo-utils >= 3.20.0
Requires: python-six >= 1.9.0
Requires: python-docker-py
Requires: python-passlib
Requires: %{name}-containers = %{version}-%{release}
Requires: python-paramiko

Provides:  tripleo-common = %{version}-%{release}
Obsoletes: tripleo-common < %{version}-%{release}

%prep
%autosetup -n %{upstream_name}-%{upstream_version} -S git
rm -rf *.egg-info

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
rm -rf {test-,}requirements.txt tools/{pip,test}-requires

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}
if [ -d %{buildroot}/%{_datadir}/%{upstream_name} ]; then
  mv %{buildroot}/%{_datadir}/%{upstream_name} %{buildroot}/%{_datadir}/%{name}
else
  # Before https://review.openstack.org/#/c/327830/3/setup.cfg
  mkdir -p %{buildroot}/%{_datadir}/%{name}
  if [ -d image-yaml ]; then
    install -d -m 755 %{buildroot}/%{_datadir}/%{name}
    cp -ar image-yaml %{buildroot}/%{_datadir}/%{name}
  fi
fi
ln -s %{name} %{buildroot}%{_datadir}/%{upstream_name}

if [ -d workbooks ]; then
  cp -ar workbooks %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/workbooks
fi

if [ -d playbooks ]; then
  cp -ar playbooks %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/playbooks
fi

if [ -d healthcheck ]; then
  cp -ar healthcheck %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/healthcheck
fi

mkdir -p %{buildroot}/%{_datadir}/%{name}-containers
mv %{buildroot}/%{_datadir}/%{name}/container-images %{buildroot}/%{_datadir}/%{name}-containers/
# compat symlink
ln -s ../%{name}-containers/container-images  %{buildroot}/%{_datadir}/%{name}/

if [ -d heat_docker_agent ]; then
  cp -ar heat_docker_agent %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/heat_docker_agent
fi

install -p -D -m 440 sudoers %{buildroot}%{_sysconfdir}/sudoers.d/%{upstream_name}

# Need this until https://review.openstack.org/506594 lands:
if [ ! -f %{_bindir}/bootstrap_host_only_eval ]; then
  echo -e '#!/bin/bash\nexit 0\n' > %{buildroot}%{_bindir}/bootstrap_host_only_eval
  chmod 0755 %{buildroot}%{_bindir}/bootstrap_host_only_eval
  echo -e '#!/bin/bash\nexit 0\n' > %{buildroot}%{_bindir}/bootstrap_host_only_exec
  chmod 0755 %{buildroot}%{_bindir}/bootstrap_host_only_exec
else
  echo "Please remove the whole if/else block in spec file if you ever read this in build logs!"
  exit 1
fi

%description
Python library for code used by TripleO projects.

%package containers
Summary: Files for building TripleO containers

%description containers
This package installs the files used to build containers for TripleO.

%package container-base
Summary: Package for the TripleO base container image
Requires: puppet
Requires: lsof
Requires: /bin/hostname

%description container-base
This package installs the dependencies and files which are required on the base
TripleO container image.

%package devtools
Summary: A collection of tools for TripleO developers and CI
Requires: %{name} = %{version}-%{release}

%description devtools
This package installs the TripleO tools for developers and CI that typically
don't fit in a product.

%files
%license LICENSE
%doc README.rst AUTHORS ChangeLog
%{python2_sitelib}/tripleo_common*
%exclude %{python2_sitelib}/tripleo_common/test*
%{_prefix}/lib/heat/undercloud_heat_plugins
%{_bindir}/upgrade-non-controller.sh
%{_bindir}/tripleo-build-images
%{_bindir}/upload-puppet-modules
%{_bindir}/upload-swift-artifacts
%{_bindir}/run-validation
%{_bindir}/create_freeipa_enroll_envfile.py
%{_datadir}/%{name}
%{_datadir}/%{upstream_name}
%{_sysconfdir}/sudoers.d/%{upstream_name}

%files containers
%{_datadir}/%{name}-containers/container-images

%files container-base
%{_bindir}/bootstrap_host_exec
%{_bindir}/bootstrap_host_only_eval
%{_bindir}/bootstrap_host_only_exec
%{_datadir}/%{name}/healthcheck

%files devtools
%{_bindir}/pull-puppet-modules

%changelog
* Thu Nov 30 2017 Mike Burns <mburns@redhat.com> 7.6.3-8
- Add exclude list to not override user data (rhbz#1516773)
- Consume resource-registry in ProcessTemplatesAction (rhbz#1518334)

* Tue Nov 28 2017 Jon Schlueter <jschluet@redhat.com> 7.6.3-7
- Prevent apache from listening on default ports (rhbz#1517903)

* Tue Nov 28 2017 Jon Schlueter <jschluet@redhat.com> 7.6.3-6
- config: Always add step conditional first for upgrade_tasks (rhbz#1516890)
- Add httpd packages to ec2api image (rhbz#1513437)
- Handle 'false' in when statements for ansible upgrade_tasks (rhbz#1516210)

* Mon Nov 27 2017 Oliver Walsh <owalsh@redhat.com> 7.6.3-5
- Generate password for libvirt TLS SCRAM auth (rhbz#1513440)

* Wed Nov 22 2017 Jon Schlueter <jschluet@redhat.com> 7.6.3-4
- Stream the Ansible output to a Zaqar queue (rhbz#1505926)
- Truncate the zaqar message to 512 kbytes (rhbz#1498916)
- Update ceph-ansible playbook path in parameter default for update (rhbz#1506214)
- Do not update the container registry if is None (rhbz#1497730)
- Add zaqarclient to TripleOAction (rhbz#1505926)

* Tue Nov 14 2017 Jon Schlueter <jschluet@redhat.com> 7.6.3-3
- Fix typos in container_images_prepare failure task names
- Add retry loop for docker pull
- Action to always populate container image parameters
- Get a static inventory for upgrade-non-controller ansible runs

* Fri Nov 10 2017 Jon Schlueter <jschluet@redhat.com> 7.6.3-2
- Set container image names for downstream (rhbz#1509324)
- Check for the existence of docker-ha.yaml (rhbz#1496782)
- Only add docker.yaml if it exists (rhbz#1496782)
- Remove mongodb and qdrouterd (rhbz#1500528 rhbz#1500531)
- [OSP 12 Only]Drop barbican, tacker, and congress containers (rhbz#1485400)
- [OSP 12 Only]Include docker.yaml and docker-ha.yaml by default (rhbz#1466744)

* Fri Nov 03 2017 RDO <dev@lists.rdoproject.org> 7.6.3-1
- Update to 7.6.3

* Tue Oct 10 2017 rdo-trunk <javier.pena@redhat.com> 7.6.2-1
- Update to 7.6.2

* Wed Oct 04 2017 rdo-trunk <javier.pena@redhat.com> 7.6.1-1
- Update to 7.6.1

* Tue Sep 12 2017 Haïkel Guémar <hguemar@fedoraproject.org> - 7.6.0-2
- Revert to python-docker-py

* Sun Sep 10 2017 rdo-trunk <javier.pena@redhat.com> 7.6.0-1
- Update to 7.6.0

* Fri Aug 25 2017 Alfredo Moralejo <amoralej@redhat.com> 7.5.0-1
- Update to 7.5.0

